;   VSAVE.ASM  Ŀ
;                                                                          
;              Vsave is a resident screenblanker for MSDOS (R)             
;              It works with every normal VGA-card and uses                
;              only 288 bytes of memory !!!!!!!                            
;                                                                          
;              Copyright (C) 1995  Ren Scholz, Germany                    
;                                                                          
; 
;                                                                           
; Ŀ
;   This program is free software; you can redistribute it and/or modify   
;   it under the terms of the GNU General Public License as published by   
;   the Free Software Foundation; either version 2 of the License, or      
;   (at your option) any later version.                                    
;                                                                          
;   This program is distributed in the hope that it will be useful,        
;   but WITHOUT ANY WARRANTY; without even the implied warranty of         
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          
;   GNU General Public License for more details.                           
;                                                                          
;   You should have received a copy of the GNU General Public License      
;   along with this program; if not, write to the Free Software            
;   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              
;                                                                          
;   > the GNU General Public Licence is included as the file "copying"   
;                                                                          
; 
                                                                            

                         INCLUDE   Macro.mac
                        .MODEL     Tiny, C


; with "Tasm /DGerman"    all messages are in German
; with "Tasm /DWin"       we use some Windows-checking-code
; with "Tasm /DSwallow"   the key which enlights the screen will be swallowed

Version_Nr   equ     "4.1"                  ; Version
CHECK        equ     "RS"                   ; Check-code for the Help_Int
minute       equ     1092                   ; 1092 = 18.2*60 sec = 1 minute
init_minute  equ     2                      ; default=2 minutes
init_time    equ     minute*init_minute     ; 2 min
Help_Int     equ     66h                    ; Help_Interrupt we use
                                            ; (in the future: int 2Fh ??)
dark         equ     0
light        equ     255

; select the position in the PSP, where the TSR is stored at
; what is the right value ?? 6Ch is _save_, but 40h seems to be OK
PSP_cut      equ     3ch                    ; use PSP above 40h
                                            ; 3Ch seems also OK

pos_1C       equ     Old_1C - Neu_1C        ; distance from the new Int's
pos_9        equ     Old_9  - Neu_9         ; to there old Vectors

bot2_old9    equ     Old_9  - Begin_of_TSR  ; distance from Begin_of_TSR to
bot2_old1C   equ     Old_1C - Begin_of_TSR  ; the Old Int-vectors

;----------------------------------------------------------------------------



; now the Program itself:

_TEXT SEGMENT
ASSUME CS: _TEXT, DS: _TEXT, ES: NOTHING, SS: NOTHING
             
                org 200h

;----------------------------------------------------------------------------
TSR_in_mem      db      0                    ; TSR in memory ? 1=yes
cmdline_copy    db      80h dup(0)           ; store command-line here
PSP             dw      0                    ; remember the PSP-Segment
state_seg       dw      0                    ; Segment:Offset of [State]
state_off       dw      0                    ; both: already in mem or not

  Flag_A equ 1000b
  Flag_C equ  100b
  Flag_L equ   10b
  Flag_R equ    1b

new_time2wait   dw      0                    ; value of new time (/Tx)
new_min_time    db      0                    ;      and new minutes
new_hotkey      db      0Ah                  ; value of new hotkey (/K=xxxx)

options         db      0                    ; remember cmd-line options here

  cmd_H equ 1       ; bit 0 = ?, H
  cmd_A equ 2       ; bit 1 = A
  cmd_P equ 4       ; bit 2 = P
  cmd_K equ 8       ; bit 3 = K
  cmd_T equ 16      ; bit 4 = T
  cmd_S equ 32      ; bit 5 = S
  cmd_U equ 64      ; bit 6 = U
;----------------------------------------------------------------------------


Anfg:
                mov     ax,ds:[2ch]          ; segment of environment
                mov     es,ax
                mov     cx,ds
                CS2DS
                mov     [PSP],cx             ; store PSP-Segment
                DOS     49h                  ; release environment
                jnc     cp_cmd_line
                WRITE   msg_env_nook

cp_cmd_line:    mov     si,Cmdline           ; save Command_Line, because
                mov     ax,[PSP]
                mov     ds,ax
                cld                          ; we use the PSP
                CS2ES                                  
                mov     di,offset cmdline_copy ; copy from DS:SI to ES:DI
                mov     cx,80h
                rep     movsb

                ASSUME  DS: _TSR             ; now accessing the _TSR-Segment
                mov     ax, _TSR
                mov     ds,ax
                GET_INT_VECTOR 9             ; remember old Vectors
                mov     [Old_9],bx           ; so we can uninstall
                mov     [Old_9+2],es         ; the TSR

                GET_INT_VECTOR 1Ch           ; old Vectors now are
                mov     [Old_1C],bx          ; before the Int's of
                mov     [Old_1C+2],es        ; the TSR in memory

                
                mov     si,offset Begin_of_TSR
                mov     ax,cs:[PSP]
                mov     es,ax                ; es now points to the PSP
                mov     di,si
                mov     cx,Length_of_TSR
                rep     movsb                ; copy the TSR into the PSP
                                             ; above PSP_cut

                ASSUME  DS: _TEXT            ; DS now addresses _TEXT again
                CS2DS
                call    Parse                ; parse cmd-line now

                test    options,cmd_H        ; only show help ?
                jz      look_for_VGA

                CLS
                WRITE   copyright
                WRITE   msg_help
do_Exit:        EXIT

look_for_VGA:   WRITE   copyright            ; better do this first ;=)
                mov     ax,1A00h             
                int     10h                  ; is a VGA installed ?
                cmp     al,1Ah
                jz      look_help_int
                WRITE   msg_no_vga
                mov     al,5
                jmp     short do_Exit        ; exit-code 5: no VGA installed

wrong_help_int:
                WRITE   msg_wrong_hi
                mov     al,7
                jmp     short do_Exit      ; exit-code 7: help_int already used

look_help_int:
                GET_INT_VECTOR Help_Int      ; can we use our Help_Int ?
                mov     ax,es
                or      ax,bx                ; int_vector=0:0 ?
                jz      store_state_2

                ; the following int will disappear in the future.
                ; then I will search through the MCB-chain for checking
                ; for an already installed TSR:
                int     Help_Int             ; Help_Int exist
                cmp     ax,CHECK             ; is it OUR Help_Int ?
                jne     wrong_help_int
                mov     [TSR_in_mem],1       ; then TSR is already in memory
                mov     ax,es
                mov     [state_seg],ax       ; store [state] of (TSR in mem)
                mov     [state_off],bx
                jmp     short test_cmd_K
;----------------------------------------------------------------------------
store_state_2:                               
                mov     ax,[PSP]             
                mov     [state_seg],ax       ; store [state] of _this_ TSR
                mov     es,ax                ; preload es with state_seg
                mov     bx,PSP_cut
                mov     [state_off],bx       ; (not already installed in MEM)
;----------------------------------------------------------------------------
test_cmd_K:
                test    options,cmd_K        ; set new hotkey ?
                jz      test_cmd_T
                                             
                mov     al,[new_hotkey]
                mov     es:[bx+(Hot_Flags - PSP_cut)],al
                WRITE   msg_new_hotkey
;----------------------------------------------------------------------------
test_cmd_T:
                test    options,cmd_T        ; set new counter ?
                jz      test_cmd_A

                mov     ax,[new_time2wait]
                mov     dl,[new_min_time]
                mov     es:[bx+(time2wait -PSP_cut)],ax ; the new counter-value
                mov     es:[bx+(min_time - PSP_cut)],dl ; the minute
                WRITE   msg_new_time
;----------------------------------------------------------------------------
test_cmd_A:
                test    options,cmd_A        ; set active ?
                jz      test_cmd_P
                                  
                mov     byte ptr es:[bx+(State - PSP_cut)],1
                WRITE   msg_active_set
;----------------------------------------------------------------------------
test_cmd_P:
                test    options,cmd_P        ; set passive ?
                jz      test_cmd_S
                                  
                mov     byte ptr es:[bx+(State - PSP_cut)],0
set_passive_3:  WRITE   msg_passive_set
;----------------------------------------------------------------------------
test_cmd_S:
                test    options,cmd_S        ; show state ?
                jnz     S_st                               
                jmp     test_cmd_U
S_st:           WRITE   msg_status
                mov     al,es:[bx+(State - PSP_cut)]
                or      al,al
                jz      S_p
                WRITE   msg_status_a
                jmp     short S_wz
S_p:            WRITE   msg_status_p
S_wz:           WRITE   msg_status_wz
                mov     dl,es:[bx+(min_time - PSP_cut)]  ; load minutes
                add     dl,'0'
                mov     ah,2                 ; write char dos-function
                int     21h                  ; write minutes
                WRITE   msg_status_min                

                mov     dh,es:[bx+(Hot_Flags - PSP_cut)] ; load hotkey
                mov     ah,2
                cmp     dh,0FFh              ; hotkey disabled ?
                jne     S_tA
                mov     dl,'0'               ; '0' means disabled
                jmp     short S_e1

S_tA:           test    dh,Flag_A
                jz      S_tC
                mov     dl,'A'               ; show chars out of 'ACLR'
                int     21h                  ; if set in hotkey
S_tC:           test    dh,Flag_C            ; 
                jz      S_tL                 ; 
                mov     dl,'C'               ; 
                int     21h
S_tL:           test    dh,Flag_L
                jz      S_tR
                mov     dl,'L'
                int     21h
S_tR:           test    dh,Flag_R
                jz      S_e2
                mov     dl,'R'
S_e1:           int     21h
S_e2:           
              IFDEF   Win                               ; if defined
                mov     ax,1600h                        ; we test if Windows
                int     2Fh                             ; v. 3.x is active.
                or      al,al                           ; then it's active,
                jz      S_e3                            ; we tell this.
                WRITE   msg_status_win
                jmp     short test_cmd_U
              ENDIF
S_e3:           WRITE   msg_status_end
;----------------------------------------------------------------------------
test_cmd_U:
                test    options,cmd_U        ; forced uninstall ?
                jz      tinstall

                or      [TSR_in_mem],0
                jnz     go_deinstall
                WRITE   msg_no_de2           ; TSR not in mem, so:
                EXIT    3                    ; Errorlevel 3: cannot deinstall

go_deinstall:                                ; TSR is in mem
                call    Test_Can_De          ; can we deinstall the TSR ?
                jc      de_exit_err
del_TSR:
                mov     dx,es:[bx+bot2_old1C]  
                mov     ax,es:[bx+bot2_old1C+2]
                mov     ds,ax
                SET_INT_VECTOR 1Ch           ; set vector back

                mov     dx,es:[bx+bot2_old9]
                mov     ax,es:[bx+bot2_old9+2]
                mov     ds,ax
                SET_INT_VECTOR 9

                xor     dx,dx
                mov     ds,dx
                SET_INT_VECTOR Help_Int

                CS2DS
                WRITE   msg_deinstall

                DOS     49h                  ; free memory of TSR in mem
                jc      de_nook              ; carry=error
                WRITE   msg_de_ok
                xor     al,al                ; exit-code 0: OK
                jmp     short de_exit
de_nook:
                WRITE   msg_de_nook
                mov     al,2                 ; exit-code 2: memory not released
de_exit:        DOS     4Ch

de_exit_err:    WRITE   msg_no_de1           ; exit-code 1: int 1ch and/or 9h
                mov     al,1                 ; are used
                jmp     short de_exit
;----------------------------------------------------------------------------
tinstall:
                xor     al,al
                or      [TSR_in_mem],al
                jz      Install_TSR

                or      [options],al
                jz      go_deinstall         ; if only "vsave", then deinstall
                jmp     short de_exit        ; cmd-line was parsed, now exit
Install_TSR:
                mov     ax,[PSP]
                mov     ds,ax                ; in DS now PSP-Segment
                
                mov     dx,offset Neu_1C     ; set the new int-vectors
                SET_INT_VECTOR 1Ch
                mov     dx,offset Neu_9
                SET_INT_VECTOR 9
                mov     dx,offset My_help_int
                SET_INT_VECTOR Help_Int

                CS2DS
                WRITE   msg_install
end_resident:
                mov     dx,offset End_of_TSR
                int     27h                  ; make Vsave resident

;-----------------------------------------------------------------------------
;                       Procedures for the transient part
;-----------------------------------------------------------------------------

Test_Can_De PROC\
                USES ax bx cx dx es
                push    es bx
                GET_INT_VECTOR 1Ch
                mov     cx,es:[bx+pos_1C]
                mov     dx,es:[bx+pos_1C+2]
                pop     bx es
                mov     ax,es:[bx+bot2_old1C]
                sub     ax,cx
                add     ax,es:[bx+bot2_old1C+2]
                sub     ax,dx
                or      ax,ax
                jnz     test_cu_err       

                push    es bx
                GET_INT_VECTOR 9
                mov     cx,es:[bx+pos_9]
                mov     dx,es:[bx+pos_9+2]   
                pop     bx es 
                mov     ax,es:[bx+bot2_old9]
                sub     ax,cx
                add     ax,es:[bx+bot2_old9+2]
                sub     ax,dx
                or      ax,ax                ; an or clears the carry-flag !!
                jz      test_cu_ok
test_cu_err:    stc
test_cu_ok:     ret
ENDP Test_Can_De

Compute_Wait_Time PROC                       ; al=x minutes
                push    bx cx
                cmp     al,1
                jb      cwt_return_err
                cmp     al,9
                ja      cwt_return_err
                xor     ah,ah                ; ax=1..9 now
                xchg    cx,ax                ; now in cl for the loop
                mov     bx,1092
                xor     ax,ax
cwt_add:        add     ax,bx
                loop    cwt_add              ; now ax=new time_to_wait
                clc                          ; ax=1092*x
                jmp     short cwt_return
cwt_return_err: stc
cwt_return:     pop     cx bx
                ret
ENDP

Parse PROC\                                  ; look for cmd-line options
                USES    ax bx cx dx si
                mov     si,offset cmdline_copy
                cld
                lodsb                        ; read lenght of cmd-line
                cbw
                xchg    cx,ax                ; cx=lenght of cmd-line
                xor     bx,bx                ; we store the options in bl
rmore:
                or      cx,cx                ; more chars on the cmd-line ?
                jnz     rmore_2
                jmp     end_of_line
rmore_2:        lodsb                        ; load next char
                dec     cx
                cmp     al,' '               ; dont need spaces ;=)
                je      rmore                ; so read more
                cmp     al,'/'
                je      rmore                ; / is no wrong syntax
cmd_0:
                cmp     al,'?'               ; show help ?
                jne     cmd_00
                or      bl,cmd_H

cmd_00:         and     al,0DFh              ; convert to upper-case
                cmp     al,'H'
                jne     cmd_1
                or      bl,cmd_H
cmd_1:
                cmp     al,'A'               ; set Vsave active ?
                jne     cmd_2
                or      bl,cmd_A
cmd_2:
                cmp     al,'P'               ; set Vsave passive ?
                jne     cmd_3
                or      bl,cmd_P
;----------------------------------------------------------------------------
cmd_3:
                cmp     al,'K'               ; change hotkey ?
                jne     cmd_4
                or      bl,cmd_K

                xor     dx,dx                ; we store the hotkey-mask in dl
                jcxz    WMSyntax             ; only K  ?
                lodsb
                dec     cx
                jcxz    WMSyntax
                cmp     al,'='               ; /K?  <-- Error, no '='
                jne     WMSyntax
                                             ; look for Int_16,ah=2 for this:
cmd_K_0:        lodsb                        ; load ACLR (Alt,Ctrl,Left,Right)
                dec     cx
                cmp     al,' '               ; space ? (following options!)
                je      cmd_K_2
                cmp     al,'0'               ; K=0 disables the hotkey
                jne     K_A
                mov     dl,0FFh
                jmp     short store_HK                         

K_A:            and     al,0DFh              ; convert to upper-case
                cmp     al,'A'               ; Alt-Key ?
                jne     K_C
                or      dl,Flag_A
                
K_C:            cmp     al,'C'               ; Control-Key ?
                jne     K_L
                or      dl,Flag_C

K_L:            cmp     al,'L'               ; LeftShift ?
                jne     K_R
                or      dl,Flag_L

K_R:            cmp     al,'R'               ; RightShift ?
                jne     cmd_K_1
                or      dl,Flag_R

cmd_K_1:        or      cx,cx
                jnz     cmd_K_0              ; read more for the hotkey

cmd_K_2:        or      dl,dl
                jnz     store_HK             
                                             ; /K=    <-- Error, no Hotkey
                                             ;            ( or wrong B^)
WMSyntax:       WRITE   msg_syntax           ; wrong cmd-line entered
                EXIT    255                  ; Syntax-Error !

store_HK:       mov     [new_hotkey],dl      ; store new hotkey
;----------------------------------------------------------------------------                
cmd_4:
                cmp     al,'T'               ; change timer ?
                jne     cmd_5
                or      bl,cmd_T
                jcxz    time_error

                lodsb                        ; al=x from /Tx
                dec     cx
                sub     al,'0'
                mov     dl,al                ; the minute
                call    Compute_Wait_Time
                jnc     cmd_T_0
time_error:
                WRITE   msg_time_err
                WRITE   msg_syntax
                EXIT    6
cmd_T_0:
                mov     [new_time2wait],ax
                mov     [new_min_time],dl
;----------------------------------------------------------------------------
cmd_5:
                cmp     al,'S'               ; show state ?
                jne     cmd_6
                or      bl,cmd_S
;----------------------------------------------------------------------------
cmd_6:
                cmp     al,'U'               ; (force) uninstall Vsave ?
                jne     loop_read            ; Note: vsave will not install
                or      bl,cmd_U             ; itself with the U option
                
loop_read:      or      bl,bl                ; was there an option 
                jz      WMSyntax             ; or a wrong syntax ?

                or      cx,cx                ; are we at the end of cmd-line ?
                jz      end_of_line
                jmp     rmore                ; read more of the cmd-line
end_of_line:
                mov     [options],bl         ; store options far later
                ret                                    
ENDP

;----------------------------------------------------------------------------


         IFDEF   German
                 INCLUDE  vsave_de.msg
         ELSE
                 INCLUDE  vsave_en.msg
         ENDIF


_TEXT ENDS

;----------------------------------------------------------------------------
;               And now: the resident part, stored above PSP_cut
;----------------------------------------------------------------------------


_TSR SEGMENT
ASSUME CS: _TSR, DS: _TSR

                org     PSP_cut
Begin_of_TSR:

;----------------------------------------------------------------------------
;db           "Do U know  Van Morrison's   Moondance  ?  It's wonderful ! "
min_time        db      init_minute       ; 2 minutes, for vsave /s
time            dw      init_time         ; count here time2wait to 0
;----------------------------------------------------------------------------

 Neu_1C  PROC
                push    ax bx ds
                CS2DS
                xor     ax,ax                            ; save some bytes !
;                or      [State],al                      ; Vsave active ?
                db      0Ch                              ; or al,?
State           db      1                                ; 1=TSR is active
                jz      go_old_1C         ; but because al was changed (or):

;                or      [Screen_State],ah               ; Screen light?
                db      80h,0CCh                         ; or ah,?
Screen_State    db      light             ; dark/light ?  (255=Ligth,0=dark)
                jz      test_mouse
count_down:                                              ; Screen is light
                call    Get_Mouse_Pos
                jne     reset_time
go_dec_time:
                dec     [time]                           ; count time to zero
                 
                jnz     go_old_1C                        ; time2wait over ?
                jmp     short crt_end_1C                 ; then dark screen

test_mouse:                                              ; Screen is dark
                call    Get_Mouse_Pos                    ; was mouse moved ?
                je      go_old_1C                        ; or mouse-key hit ?
                mov     bx,0FF20h
crt_end_1C:
                call    Set_CRT
reset_time:
;                mov     ax,[time2wait]
                db      0B8h                             ; mov ax,?
time2wait       dw      init_time         ; can be changed by vsave /Tx
                mov     [time],ax
                
go_old_1C:      
                pop     ds bx ax
                db      0EAh             ; jmp far      ; jump into old Int_1C
Old_1C          dw      0, 0                            ; remember old Int_1C
Neu_1C ENDP

;-----------------------------------------------------------------------------

Neu_9  PROC
                or      cs:[State],0                    ; Vsave active or not?
                jnz     get_key_code
                db      0EAh             ; jmp far      ; jump into old Int_9
Old_9           dw      0, 0                            ; remember old Int_9

get_key_code:   push    ax bx ds
                CS2DS
                xor     bx,bx
                in      al,60h                          ; get the key-code
                pushf
                call    dword ptr [Old_9]               ; put it into the
                                                        ; keyboard-buffer
                cmp     al,80h                          ; Release code ?
                jae     iret_end_9
                LOOK_KEY_STATUS
                and     al,00001111b                    ; is it our Hotkey ?
                db      3Ch 
Hot_Flags       db      0Ah                        ; Hotkey: <left-Shift> + Alt
                ; ^^^^^^^^ cmp     al,[Hot_Flags]

                jne     key_hit
crt_end_9:      call    Set_CRT                         ; Hotkey was hit:
                                                        ; set Screen off
iret_end_9:     pop     ds bx ax
                iret
key_hit:
                mov     ax,[time2wait]                  ; ANY-Key was hit :)
                mov     [time],ax
                or      [Screen_State],bh               ; is the Screen dark ?
                jnz     iret_end_9
light_the_screen:                     
                mov     bx, 0FF20h                      ; set screen on
              IFDEF   Swallow
                LOOK_KEY                                ; was a _key_ pressed?
                jz      crt_end_9
                READ_KEY                                ; a key was pressed
                                                        ; clear kbd-buffer
              ENDIF
                jmp     short crt_end_9
Neu_9  ENDP

;----------------------  Procedures in the resident part  --------------------

PROC Set_CRT\
              USES    dx
              IFDEF   Win                               ; if defined
                mov     ax,1600h                        ; we test if Windows
                int     2Fh                             ; v. 3.x is active.
                or      al,al                           ; then we don't set
                jnz     end_crt                         ; the crt.
              ENDIF
                cli
                mov     dx,3DAh                         ; reset status_reg
                in      al,dx                           ;       (color)
                mov     dl,0BAh                         ; reset status_reg
                in      al,dx                           ;       (monochrom)
                mov     dl,0C0h                         ; set crt-controller
                xchg    ax,bx                           ; on/off
                out     dx,al
                mov     [Screen_State],ah               ; light or dark
                sti
end_crt:        ret
ENDP Set_CRT

PROC Get_Mouse_Pos\
                USES    cx dx
                mov     ax,3
                xor     cx,cx                           ; if no mouse-driver
                xor     dx,dx                           ; is installed
                int     33h                             ; get mouse-position
                xchg    ax,cx
                add     ax,dx
                add     ax,bx                           ; add the mousekeys too
;                cmp     ax,[mouse_pos]                 ; was mouse moved ?
                db      3Dh                             ; cmp ax,?
Mouse_pos       dw      0
                mov     [mouse_pos],ax
                ret
ENDP Get_Mouse_Pos

PROC My_help_int
                mov     ax,CHECK                    ; return check-code
                mov     bx,cs                       ; return Segment of the TSR
                mov     es,bx
                mov     bx,offset cs:Begin_of_TSR   ; return Offset of
                iret                                ; Begin_of_TSR
ENDP My_help_int

End_of_TSR:
Length_of_TSR equ End_of_TSR - Begin_of_TSR
 
_TSR ENDS
                       
;----------------------------------------------------------------------------
; End of resident part
;----------------------------------------------------------------------------


END            Anfg
